############### CUTSCENES
transform cutscene_transform_walk:
    xpos sX
    ypos sY
    xzoom dir
    linear dist/speed xpos mX ypos mY

transform cutscene_transform_stand:
    xpos sX
    ypos sY
    xzoom dir

transform cutscene_transform_walk_sorc:
    xpos sX_sorc
    ypos sY_sorc
    xzoom dir_sorc
    linear dist_sorc/speed_sorc xpos mX_sorc ypos mY_sorc

transform cutscene_transform_stand_sorc:
    xpos sX_sorc
    ypos sY_sorc
    xzoom dir_sorc

init python:
    import math
    def cutscene_navigation(mX0,mY0,dir0,sprite="prince",emotion="stand",movespeed=4.0):
        global sX
        global sY
        global dir
        global mX
        global mY
        global dist
        global speed
        global walktime
        mX = mX0
        mY = mY0
        dir = dir0
        xD = sX-mX
        yD = sY-mY
        dist = math.sqrt((xD**2)+(yD**2))
        speed = movespeed*100.0
        walktime = int(math.ceil((dist/speed)/0.3))
        if floor_type == "carpet":
            renpy.play(walk_carpet(walktime),channel="walking")
        elif floor_type == "tile":
            renpy.play(walk_tile(walktime),channel="walking")
        else:
            renpy.play(walk_dirt(walktime),channel="walking")
        renpy.show(name=sprite + " walk",zorder=10,layer="screens",at_list=[cutscene_transform_walk])#,linear=dist/500.0
        renpy.pause(delay=dist/speed, hard=True)
        sX=mX
        sY=mY
        renpy.show(name=sprite + " " + emotion,zorder=10,layer="screens",at_list=[cutscene_transform_stand])

    def cutscene_navigation_sorc(mX0,mY0,dir0,sprite="sorceress",emotion="stand",movespeed=3.0):
        global sX_sorc
        global sY_sorc
        global dir_sorc
        global mX_sorc
        global mY_sorc
        global dist_sorc
        global speed_sorc
        global walktime
        mX_sorc = mX0
        mY_sorc = mY0
        dir_sorc = dir0
        dist_sorc = math.sqrt(((sX_sorc-mX_sorc)**2)+((sY_sorc-mY_sorc)**2))
        speed_sorc = movespeed*100.0
        walktime = int(math.ceil((dist_sorc/speed_sorc)/0.5))
        renpy.play(walk_dirt_sorc(walktime),channel="walking")
        renpy.show(name=sprite + " walk",zorder=9,layer="screens",at_list=[cutscene_transform_walk_sorc])#,linear=dist/500.0
        renpy.pause(delay=dist_sorc/speed_sorc, hard=True)
        sX_sorc=mX_sorc
        sY_sorc=mY_sorc
        renpy.show(name=sprite + " " + emotion,zorder=9,layer="screens",at_list=[cutscene_transform_stand_sorc])


label cutscene_1:
    # show hair_sink still zorder 9 onlayer screens:
    #     xpos 550
    #     ypos 400
    show hair_floordrain still zorder 9 onlayer screens with Dissolve(0.5):
        xpos 17
        ypos 550
    hide screen checkMouse
    $ clickable=False
    $ cutscene=True
    $ infobox = ""

    "Alright! Shower time!"

    $ standWalk=1
    $ cutscene_navigation(mX0=500,mY0=400,dir0=-1.0)

    "The water will take a little while to warm up, so -"

    show prince scared zorder 10 onlayer screens at cutscene_transform_stand

    "Ahhh!"

    # hair slither
    show hair_floordrain anim zorder 9 onlayer screens:
        xpos 17
        ypos 550

    $ renpy.pause(0.2)
    play sound "audio/sounds/sickdrop.ogg"
    show flashing_light black_anim zorder 20 onlayer screens:
        xpos 0
        ypos 0

    $ cutscene_navigation(mX0=700,mY0=400,dir0=-1.0,emotion="scared")

    "W-Was that hair...?!"

    "B-But mine isn't even close to being that long...! Whose -"

    show hair_sink anim2 zorder 9 onlayer screens:
        xpos 880
        ypos 420

    $ renpy.pause(0.2)
    $ dir = 1.0
    show prince scared zorder 10 onlayer screens at cutscene_transform_stand
    play sound "audio/sounds/spooky1.ogg"
    show flashing_light black_anim zorder 20 onlayer screens:
        xpos 0
        ypos 0

    $ renpy.pause(1.0)

    show hair_sink anim zorder 9 onlayer screens:
        xpos 880
        ypos 420

    "Eek! In the sink too?! Where is it coming from?"

    show hair_sink anim1 zorder 9 onlayer screens:
        xpos 880
        ypos 420

    $ renpy.pause(1.0)

    "There's no way I'm taking a shower now."

    prince "Let's get out of here!"

    $ floor1_cutscenes.append(1)

    $ clickable=True
    $ cutscene=False
    $ renpy.choice_for_skipping()
    show screen checkMouse
    jump stand

label cutscene_2:
    hide screen checkMouse
    $ clickable=False
    $ cutscene=True
    $ infobox = ""

    # movement
    $ cutscene_navigation(mX0=1100,mY0=400,dir0=-1.0)

    "Why would the window be boarded up? Is something out there?"

    "Or is something in here...?"

    $ dir = 1.0
    show prince stand zorder 10 onlayer screens at cutscene_transform_stand

    "My stomach is in knots. I need some medicine."

    $ floor1_cutscenes.append(2)

    $ clickable=True
    $ cutscene=False
    $ renpy.choice_for_skipping()
    show screen checkMouse
    jump stand

label cutscene_3:
    hide screen checkMouse
    $ clickable=False
    $ cutscene=True
    $ infobox = ""

    "Mom falls asleep at the table sometimes after work. I almost hoped I would find her here..."

    $ cutscene_navigation(mX0=1100,mY0=400,dir0=-1.0)

    # movement
    #$ cutscene_navigation(mX0=700,mY0=400,dir0=-1.0,emotion="scared")

    show hair_sink anim3 zorder 9 onlayer screens:
        xpos 750
        ypos 375

    $ renpy.pause(0.2)

    play sound "audio/sounds/spooky1.ogg"

    show flashing_light black_anim zorder 20 onlayer screens:
        xpos 0
        ypos 0

    $ dir = -1.0
    show prince scared zorder 10 onlayer screens at cutscene_transform_stand

    prince "Not more hair! No, no, no! Stop it!"

    "..."

    $ dir = -1.0
    show prince scared zorder 10 onlayer screens at cutscene_transform_stand

    "......"

    "Is... Is it okay now?"

    $ dir = 1.0
    show prince stand zorder 10 onlayer screens at cutscene_transform_stand

    prince "Nevermind medicine! I've got to get out of here! Mom! I have to find Mom!"

    $ floor1_cutscenes.append(3)

    $ clickable=True
    $ cutscene=False
    $ renpy.choice_for_skipping()
    show screen checkMouse
    jump stand

label cutscene_4:
    hide screen checkMouse
    $ clickable=False
    $ cutscene=True
    $ infobox = ""

    "Okay. Let's go!"

    # movement
    $ cutscene_navigation(mX0=50,mY0=400,dir0=-1.0,emotion="stand",movespeed=6.0)

    $ renpy.pause(0.2)

    play sound "audio/sounds/doorlocked1.ogg"

    $ renpy.pause(1.5)

    show prince scared zorder 10 onlayer screens at cutscene_transform_stand

    ## rattle sound
    "Huh? It won't open!"

    play sound "audio/sounds/doorlocked1.ogg"

    $ renpy.pause(1.5)

    ## rattle sound
    ## rattle sound
    prince "Mom! Mooom!"

    $ cutscene_navigation(mX0=100,mY0=400,dir0=-1.0,emotion="scared")

    "I'm scared..."

    show hair_door anim zorder 9 onlayer screens:
        xpos 0
        ypos 900

    $ renpy.pause(0.2)
    play sound "audio/sounds/sickdrop.ogg"
    show flashing_light black_anim zorder 20 onlayer screens:
        xpos 0
        ypos 0

    $ renpy.pause(0.2)

    $ cutscene_navigation(mX0=200,mY0=400,dir0=-1.0,emotion="scared")

    prince "Ahhh! Not again! Now I know I'm not just seeing things..."

    "Think, think, think."

    $ dir = 1.0
    show prince stand zorder 10 onlayer screens at cutscene_transform_stand

    "The window, those boards... I can pry them off to get out of here. Okay. There should be a toolbox under the sink."

    #show prince happy zorder 10 onlayer screens at cutscene_transform_stand

    "I'll be alright as long as I leave. It's not safe here anymore."

    $ floor1_cutscenes.append(4)

    $ clickable=True
    $ cutscene=False
    $ renpy.choice_for_skipping()
    show screen checkMouse
    jump stand

label cutscene_5:
    hide screen checkMouse
    $ clickable=False
    $ cutscene=True
    $ infobox = ""

    "Okay. I can use the stepstool to reach the key."

    $ floor1_buttons["kitchen_stepstool_placed"] = True

    play sound "audio/sounds/stepstool1.ogg"

    $ cutscene_navigation(mX0=168,mY0=450,dir0=-1.0)
    $ cutscene_navigation(mX0=168,mY0=150,dir0=-1.0,movespeed=7.0)

    $ cutscene_navigation(mX0=168,mY0=450,dir0=1.0,movespeed=7.0)

    "Yes! Got it!"

    $ cutscene_navigation(mX0=300,mY0=450,dir0=1.0)

    "To the window!"

    $ floor1_buttons["kitchen_stepstool_placed"] = False
    play sound "audio/sounds/inventorychime1.ogg"
    $ new_item = "Toolbox Key"
    $ inventory_add_toggle = True
    $ inventorylist.append("Toolbox Key")

    $ floor1_cutscenes.append(5)

    $ clickable=True
    $ cutscene=False
    $ renpy.choice_for_skipping()
    show screen checkMouse
    # unique
    show screen inventory_add
    jump stand

label cutscene_6:
    hide screen checkMouse
    $ clickable=False
    $ cutscene=True
    $ infobox = ""

    $ dir = 1.0
    show prince scared zorder 10 onlayer screens at cutscene_transform_stand

    prince "Where am I?"

    "Everything's changed. The ground is so much farther below. My legs are shaking..."

    show prince stand zorder 10 onlayer screens at cutscene_transform_stand

    "It's not the apartment anymore. It's... a tower, so tall it disappears into the clouds above."

    $ dir = -1.0

    "Nowhere to go but up. Should I climb?"

    $ floor1_cutscenes.append(6)

    $ clickable=True
    $ cutscene=False
    $ renpy.choice_for_skipping()
    show screen checkMouse
    jump stand

label cutscene_7:
    hide screen checkMouse
    $ clickable=False
    $ cutscene=True
    $ infobox = ""

    "I can do this."

    "Maybe there's someone else up there. Maybe they can help me."

    "Time to climb!"

    $ prev_room = "stairs_f1"

    $ cutscene_navigation(mX0=420,mY0=103,dir0=1.0)
    $ cutscene_navigation(mX0=674,mY0=-(charadj_y + 100),dir0=1.0)
    $ cutscene_navigation(mX0=707,mY0=-(charadj_y + 100),dir0=-1.0)

    show intro empty zorder 60 onlayer screens with Dissolve(1.0)
    show screen stairs_f2_screen_bg
    show screen stairs_f2_screen_top
    show intro empty_true zorder 60 onlayer screens with Dissolve(1.0)

    $ sX = 0
    $ sY = 1080
    $ dir = 1.0
    show prince stand zorder 10 onlayer screens at cutscene_transform_stand

    # where the transformation happens
    $ is_transformed = True

    $ cutscene_navigation(mX0=600,mY0=200,dir0=1.0)

    "Made it."

    $ cutscene_navigation(mX0=800,mY0=200,dir0=1.0)

    "I think I'll be able to open that big window over there... and then I can climb in, right?"

    "Yeah and -"

    $ dir = -1.0
    show prince scared zorder 10 onlayer screens at cutscene_transform_stand

    prince "Huh? These aren't my clothes!"

    $ dir = 1.0
    show prince scared zorder 10 onlayer screens at cutscene_transform_stand

    $ renpy.pause(0.5)

    $ dir = -1.0
    show prince scared zorder 10 onlayer screens at cutscene_transform_stand

    $ renpy.pause(0.5)

    prince "This is impossible. Am I dreaming?"

    show prince stand zorder 10 onlayer screens at cutscene_transform_stand

    prince "If I am, it can't hurt to keep going."

    $ char_lock = False

    #$ clickable = True

    $ floor1_cutscenes.append(7)

    $ clickable=True
    $ cutscene=False
    $ renpy.choice_for_skipping()
    show screen checkMouse
    jump stairs_f2
