
#### IMAGE SETUP

###################### floor 1
image bg f1_bedroom = "bg/bg_bedroom2.png"
image bg f1_hallway = "bg/bg_hallway.png"
image bg f1_bathroom = "bg/bg_bathroom.png"
image bg f1_livingroom = "bg/bg_livingroom.png"
image bg f1_kitchen = "bg/bg_kitchen.png"
image bg f1_stairs = "bg/bg_stairs.png"

###################### floor 2+ (we no longer specify)
image bg empty = "bg/empty.png"

########################### RAPUNZEL
image rapunzel stand = "sprites/test/r_stand.png"

image rapunzel walk:
    "sprites/test/r_walk1.png"
    0.1
    "sprites/test/r_walk2.png"
    0.1
    "sprites/test/r_walk3.png"
    0.1
    "sprites/test/r_walk4.png"
    0.1
    repeat

image enemy stand = "sprites/test/e_stand.png"

image enemy walk:
    "sprites/test/e_walk1.png"
    0.1
    "sprites/test/e_walk2.png"
    0.1
    "sprites/test/e_walk3.png"
    0.1
    "sprites/test/e_walk4.png"
    0.1
    repeat

define boy1 = Character("First Boy")
define boy2 = Character("Second Boy")
define boy3 = Character("Third Boy")
define boy4 = Character("Fourth Boy")
define stranger = Character("???")

############################## VARIABLE SETUP
default objectives_toggle = False
default inventory_toggle = False
default inventorylist = []
default floor1_cutscenes = [0]
default floor2_cutscenes = [0]
default new_item = ""
default inventory_add_toggle = False

# movement
define sX= -500
define sY= 400
default mX=0
default mY=0
default mY_0 = 0
default dist=0
default speed=400.0
default charadj_x = 120
default charadj_y = 550
default diff = 300
default floor_type = "carpet"
default char_lock = False
default walktime = 0.0
default chapel2_infobox = ""
default infobox = ""

# movement - sorceress
define sX_sorc = -500
define sY_sorc = 50
default dir_sorc = 1.0
default mX_sorc = 0
default mY_sorc = 0
default dist_sorc = 0
default speed_sorc = 400.0

# position
default standWalk=0
default rX= 0
default dir = 1.0

# interaction
default cutscene = False
default clickable = False
default button_alex = False

# beginning rooms
default floor1 = "static"
default prev_room = "static"
default is_transformed = False
default sorceress_ver = 1
default trigger_goodend = False
default trigger_painting_text = False

# grave puzzle
default dig_recent = False
default g_boy1 = 0
default g_boy2 = 0
default g_boy3 = 0
default g_boy4 = 0

default maxY_base = 1050 - charadj_y
default minY_base = 950 - charadj_y
default maxX_base = 1800 - charadj_x
default minX_base = 0 - charadj_x

default maxY = maxY_base
default minY = minY_base
default maxX = maxX_base
default minX = minX_base

# win conditions
# default win = 0

# button visibility
# default a1 = True
# default a2 = True
# default a3 = True

# default bathroom_sink_toggle = False
# default bedroom_dresser_toggle = False
# default bedroom_mirror_toggle = False
# default bedroom_bed_toggle = False
# default bedroom_picture_toggle = False
# default bedroom_poster_toggle = False
# default bedroom_medal_toggle = False

init:
    $ config.tag_layer['bg'] = 'background'

init python:
    import math

    renpy.music.register_channel("walking", loop=False, tight=True, file_suffix=".ogg", file_prefix="audio/sounds/", mixer="sfx")
    renpy.music.register_channel("ambience", loop=False, tight=True, file_suffix=".ogg", file_prefix="audio/ambience/", mixer="sfx")

    def walk_carpet(num):
        return ["walk_carpet1",]*num

    def walk_tile(num):
        return ["walk_tile1",]*num

    def walk_dirt(num):
        return ["walk_dirt1",]*num

    def walk_dirt_sorc(num):
        return ["walk_dirt2",]*num

    ## FLOOR 1
    floor1_ints = {
        "bedroom_dresser" : False,
        "bedroom_mirror" : False,
        "bedroom_bed" : False,
        "bedroom_picture" : False,
        "bedroom_poster" : False,
        "bedroom_medal" : False,
        "bedroom_soccer" : False,
        "bedroom_pile" : False,
        "bedroom_doll" : False,
        "bathroom_sink" : False,
        "livingroom_portrait": False,
        "livingroom_boards" : False,
        "livingroom_TV" : False,
        "stairs_f1_attempt" : False,
        "stairs_f1_ladder" : False,
        "kitchen_fridge" : False,
        "kitchen_stepstool" : False,
        "kitchen_stepstool_placed" : False,
        "kitchen_undersink" : False
    }
    floor1_nav = {
        "bedroom" : False,
        "hallway" : False,
        "bathroom" : False,
        "livingroom" : False,
        "kitchen" : False,
        "stairs_f1" : False
    }
    floor1_buttons = {
        "livingroom_portrait" : True,
        "livingroom_boards" : False,
        "kitchen_stepstool" : True,
        "kitchen_stepstool_placed" : False
    }

    ## FLOOR 2
    floor2_ints = {
        "stairs_f2_ladder" : False,
        "bedroom2_bed" : False,
        "bedroom2_lantern_chain" : False,
        "hallway2_lantern" : False,
        "livingroom2_couch" : False,
        "livingroom2_window" : False,
        "chapel2_celing" : False,
        "chapel2_shovel" : False,
        "chapel2_statue" : False,
        "chapel2_grave1" : False,
        "chapel2_grave2" : False,
        "chapel2_grave3" : False,
        "chapel2_grave4" : False,
        "chapel2_cross" : False,
        "painting2_painting" : False,
        "painting2_painting_label" : False,
        "painting2_boy1" : False,
        "painting2_boy2" : False,
        "painting2_boy3" : False,
        "painting2_boy4" : False
    }
    floor2_nav = {
        "bedroom2" : False,
        "livingroom2" : False,
        "hallway2" : False,
        "chapel2" : False,
        "painting2" : False,
        "stairs_f2" : False
    }
    floor2_buttons = {
        "bedroom2_lantern" : False,
        "bedroom2_chain" : False,
        "bedroom2_lantern_chain" : True,
        "bedroom2_window" : True,
        "chapel2_shovel" : True,
        "chapel2_grave1" : True,
        "chapel2_grave2" : True,
        "chapel2_grave3" : True,
        "chapel2_grave4" : True
    }

##################################################################################

#### GAME START/ROOMS
label start:

    python:
        ## FLOOR 1
        floor1_ints = {
            "bedroom_dresser" : False,
            "bedroom_mirror" : False,
            "bedroom_bed" : False,
            "bedroom_picture" : False,
            "bedroom_poster" : False,
            "bedroom_medal" : False,
            "bedroom_soccer" : False,
            "bedroom_pile" : False,
            "bedroom_doll" : False,
            "bathroom_sink" : False,
            "livingroom_portrait": False,
            "livingroom_boards" : False,
            "livingroom_TV" : False,
            "stairs_f1_attempt" : False,
            "stairs_f1_ladder" : False,
            "kitchen_fridge" : False,
            "kitchen_stepstool" : False,
            "kitchen_stepstool_placed" : False,
            "kitchen_undersink" : False
        }
        floor1_nav = {
            "bedroom" : False,
            "hallway" : False,
            "bathroom" : False,
            "livingroom" : False,
            "kitchen" : False,
            "stairs_f1" : False
        }
        floor1_buttons = {
            "livingroom_portrait" : True,
            "livingroom_boards" : False,
            "kitchen_stepstool" : True,
            "kitchen_stepstool_placed" : False
        }

        ## FLOOR 2
        floor2_ints = {
            "stairs_f2_ladder" : False,
            "bedroom2_bed" : False,
            "bedroom2_lantern_chain" : False,
            "hallway2_lantern" : False,
            "chapel2_celing" : False,
            "chapel2_shovel" : False,
            "chapel2_statue" : False,
            "chapel2_grave1" : False,
            "chapel2_grave2" : False,
            "chapel2_grave3" : False,
            "chapel2_grave4" : False,
            "chapel2_cross" : False,
            "painting2_painting" : False,
            "painting2_painting_label" : False,
            "painting2_boy1" : False,
            "painting2_boy2" : False,
            "painting2_boy3" : False,
            "painting2_boy4" : False
        }
        floor2_nav = {
            "bedroom2" : False,
            "hallway2" : False,
            "chapel2" : False,
            "painting2" : False,
            "stairs_f2" : False
        }
        floor2_buttons = {
            "bedroom2_lantern" : False,
            "bedroom2_chain" : False,
            "bedroom2_lantern_chain" : True,
            "bedroom2_window" : True,
            "chapel2_shovel" : True,
            "chapel2_grave1" : True,
            "chapel2_grave2" : True,
            "chapel2_grave3" : True,
            "chapel2_grave4" : True
        }


    $ style.say_window = style.window_cutscene

    $ _skipping = False

    #show bg empty onlayer screens zorder 0 with Dissolve(0.5)

    scene bg empty onlayer backgrounds with Dissolve(0.5)

    show intro empty zorder 60 onlayer screens with Dissolve(2.0)

    play ambience "snowfall" loop fadein 8.0

    pause 2.0

    stop music fadeout 6.0

    "I told Mom I'd come in if the weather got bad."

    window hide

    show intro building zorder 60 onlayer screens
    show intro_snow building zorder 62 onlayer screens

    show intro_birds building zorder 61 onlayer screens

    pause 2.0

    "I promised."

    window hide

    show intro dani zorder 60 onlayer screens
    show intro_snow dani zorder 62 onlayer screens

    pause 1.0

    "This place might be more fun if I had someone to play with."

    window hide

    pause 1.0

    "If I'm gonna have to move again, maybe it's better that I'm alone... but..."

    window hide

    show intro dani_closing zorder 60 onlayer screens

    #pause 8.3

    show intro empty zorder 64 onlayer screens with Dissolve(9.0)

    show intro_snow empty zorder 62 onlayer screens with Dissolve(0.5)
    show intro_birds empty zorder 61 onlayer screens with Dissolve(0.5)

    play sound "audio/sounds/walk_snow1.ogg"

    pause 2.0

    show intro door_opening zorder 60 onlayer screens

    play sound "audio/sounds/dooropen1.ogg"

    pause 0.9

    show intro door zorder 60 onlayer screens

    pause 1.0

    "... but... maybe this time, I'll get to stay."

    window hide

    stop ambience fadeout 3.0

    pause 1.0

    show intro empty_true zorder 60 onlayer screens with Dissolve(2.0)

    "Anyway, Mom is gone today - probably at work."

    #scene bg f1_bedroom onlayer backgrounds with Dissolve(2.0)

    window hide
    $ standWalk=0

    $ maxY = 1000 - charadj_y
    $ minY = 950-charadj_y

    show screen bedroom_screen_bg
    show screen bedroom_screen_top

    play ambience "apartment" loop fadein 2.0

    show prince stand zorder 10 onlayer screens:
        xpos sX
        ypos sY
        xzoom dir

    $ cutscene_navigation(mX0=950,mY0=400,dir0=1.0,movespeed=7.0)

    $ style.say_window = style.window

    show screen interaction_bg

    "I should get cleaned up."

    show screen checkMouse

    $ clickable = True
    $ cutscene = False

    $ renpy.pause(hard=True)

################################################ NAVIGATION
# basic standing animation
label stand:
    window hide
    $ standWalk=0
    $ clickable=True

    show prince stand zorder 10 onlayer screens:
        xpos sX
        ypos sY
        xzoom dir

    ######## item interaction
    python:
        for (k, v) in floor1_ints.items():
            if v:
                renpy.jump(k)

        for (k, v) in floor2_ints.items():
            if v:
                renpy.jump(k)

    ######## navigation
    python:
        for (k, v) in floor1_nav.items():
            if v:
                renpy.hide("prince")
                renpy.jump(k)

        for (k, v) in floor2_nav.items():
            if v:
                renpy.hide("prince")
                renpy.jump(k)

    $ renpy.pause(hard=True)

# basic walking animation
label walk:
    $ standWalk=1
    $ clickable=False

    $ walktime = int(math.ceil((dist/500.0)/0.3))

    if floor_type == "carpet":
        play walking walk_carpet(walktime)
    elif floor_type == "tile":
        play walking walk_tile(walktime)
    else:
        play walking walk_dirt(walktime)

    show prince walk zorder 10 onlayer screens:
        xpos sX
        ypos sY
        xzoom dir
        linear dist/500.0 xpos mX ypos mY

    $ renpy.pause(delay=dist/500.0, hard=True)
    $ sX = mX
    $ sY = mY
    jump stand
# basic distance calculation
label checkDist:
    $ cutscene=False
    if clickable and not char_lock:
        $ mX_0=renpy.get_mouse_pos()[0]
        $ mY_0=renpy.get_mouse_pos()[1]

        # adj
        $ mX_1 = mX_0 - charadj_x
        $ mY_1 = mY_0 - charadj_y

        # limit y movement
        if mY_1 > maxY:
            $ mY = maxY #+ charadj_y
        elif mY_1 < minY:
            $ mY = minY #- charadj_y
        else:
            $ mY = mY_1

        # limit x movement
        if mX_1 > maxX:
            $ mX = maxX #+ charadj_y
        elif mX_1 < minX:
            $ mX = minX #- charadj_y
        else:
            $ mX = mX_1

        $ diff = abs(mX-sX)

        if diff < 50:
            if mX < sX:
                if mX == minX:
                    $ mX = mX + 50
                else:
                    $ mX = mX - 50
            else:
                if mX == maxX:
                    $ mX = mX - 50
                else:
                    $ mX = mX + 50

        # choose direction
        if mX > sX + charadj_x:
            $ dir = 1.0
        else:
            $ dir = -1.0

        $ xD = sX-mX
        $ yD = sY-mY
        $ dist = (xD**2)+(yD**2)
        $ dist = math.sqrt(dist)
        jump walk

    else:
        jump stand



############### extra interfaces








############################################### TEST ROOMS
# test - this needs to be expanded for each avail button
# label button_alex2:
#     $ button_alex = False
#     $ win += 1
#     hide screen checkMouse
#
#     "Alex is very tired."
#     $ floor1_buttons = floor1_buttons_prep
#
#     if win == 3:
#         "Congratulations! You beat the test area."
#         return
#     else:
#         show screen checkMouse
#         jump checkDist

# swapping rooms
# label room2:
#     scene bg room2 onlayer backgrounds with dissolve
#     show screen Int_Test2
#     show screen Int_Test2_Top
#     $ floor1 = "static"
#
#     window hide
#     $ standWalk=0
#     # place sprite
#     $ sX = 1200
#     $ sY = 300
#
#     show prince stand zorder 10 onlayer screens with dissolve:
#         xpos sX
#         ypos sY
#         xzoom dir
#
#     show screen checkMouse
#
#     $ renpy.pause(hard=True)
#
# label room1:
#     scene bg room onlayer backgrounds with dissolve
#     show screen Int_Test
#     show screen Int_Test_Top
#     $ floor1 = "static"
#
#     window hide
#     $ standWalk=0
#     # place sprite
#     $ sX = 150
#     $ sY = 300
#
#     show prince stand zorder 10 onlayer screens with dissolve:
#         xpos sX
#         ypos sY
#         xzoom dir
#
#     show screen checkMouse
#
#     $ renpy.pause(hard=True)
